local voicelines = {"g10", "g23", "g29", "g60", "f42_any"}

MBE = MBE or {}	
MBE.save_path = SavePath .. "MarkBossEnemies.json"
MBE.mod_path = ModPath
MBE.settings = {
    voiceline = 5
}
if io.file_is_readable(MBE.save_path) then
    MBE.settings = io.load_as_json(MBE.save_path)
end

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInitMBE", function(loc)
	local custom_language
	for _, mod in pairs(BLT and BLT.Mods:Mods() or {}) do
		if mod:GetName() == "PAYDAY 2 THAI LANGUAGE Mod" and mod:IsEnabled() then
			custom_language = "thai"
			break
		end
	end
	if custom_language then
		loc:load_localization_file(MBE.mod_path .. "loc/" .. custom_language ..".txt")
	elseif PD2KR then
		loc:load_localization_file(MBE.mod_path .. "loc/korean.txt")
	else
		local loaded = false
		if Idstring("english"):key() ~= SystemInfo:language():key() then
			for _, filename in pairs(file.GetFiles(MBE.mod_path .. "loc/") or {}) do
				local str = filename:match("^(.*).txt$")
				if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
					loc:load_localization_file(MBE.mod_path .. "loc/" .. filename)
					loaded = true
					break
				end
			end
		end
		if not loaded then
			local file = MBE.mod_path .. "loc/" .. BLT.Localization:get_language().language .. ".txt"
			if io.file_is_readable(file) then
				loc:load_localization_file(file)
			end
		end
	end
	loc:load_localization_file(MBE.mod_path .. "loc/english.txt", false)
end)

Hooks:Add("MenuManagerBuildCustomMenus", "MenuManagerBuildCustomMenusMBE", function(menu_manager, nodes)

    function MenuCallbackHandler:MBE_value(item)
        MBE.settings[item:name()] = item:value()
    end

    function MenuCallbackHandler:MBE_save()
        io.save_as_json(MBE.settings, MBE.save_path)
    end

    local menu_id = "MBE_menu"
    MenuHelper:NewMenu(menu_id)

    MenuHelper:AddMultipleChoice({
        id = "voiceline",
        title = "menu_MBEmenu_option_title",
        desc = "menu_MBEmenu_option_desc",
        callback = "MBE_value",
        value = MBE.settings.voiceline,
        items = { "menu_MBEmenu_option_1", "menu_MBEmenu_option_2", "menu_MBEmenu_option_3", "menu_MBEmenu_option_4", "menu_MBEmenu_option_5"},
        menu_id = menu_id
		
    })

    nodes[menu_id] = MenuHelper:BuildMenu(menu_id, { back_callback = "MBE_save" })
    MenuHelper:AddMenuItem(nodes["blt_options"], menu_id, "menu_MBEmenu", "menu_MBEmenu_desc")
end)

Hooks:PostHook(CharacterTweakData,"init","mod_init",function(self)

	self.boss_priority_shout = voicelines[MBE.settings["voiceline"]]

	self.drug_lord_boss.priority_shout = self.boss_priority_shout
	self.chavez_boss.priority_shout = self.boss_priority_shout
	self.mobster_boss.priority_shout = self.boss_priority_shout
	self.hector_boss.priority_shout = self.boss_priority_shout
	self.biker_boss.priority_shout = self.boss_priority_shout
	self.triad_boss.priority_shout = self.boss_priority_shout

end)